/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_FLASHITEM_H__725F0158_64A1_4B97_BB53_C112896921AB__INCLUDED_)
#define AFX_FLASHITEM_H__725F0158_64A1_4B97_BB53_C112896921AB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class FlashItem  
{
public:
	FlashItem(const string &name);
	virtual ~FlashItem();

	void load(HINSTANCE hInstance, const string &flashpath);

	void setAlwaysOnTop(bool setalwaysOnTop, bool firstSetup = false);

	void hide();
	void show();

	void reposition(int type, int newx, int newy, int newwidth, int newheight, bool repositionBy = false);

	const string &getName() const { return name; };
	bool isAlwaysOnTop() const { return alwaysOnTop; };
	bool isVisible() const { return visible; };
	bool isStartHidden() const { return startHidden; };

private:

	HWND hWnd;
	HWND hWndFlash;
	HINSTANCE hInstance;

	HDC memoryDC;
	HBITMAP memoryBitmap;

	int maskWidth;
	int maskHeight;

	string name;

	string flashPath;

	bool alwaysOnTop;
	bool startHidden;
	bool visible;

	int actualx;
	int actualy;
	int actualwidth;
	int actualheight;

	void updateRegion();

protected:

	virtual bool onWindowMessage(UINT message, WPARAM wParam, LPARAM lParam, LRESULT &lResult);

public:

	static LRESULT WINAPI windowProcedure(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

};

#endif // !defined(AFX_FLASHITEM_H__725F0158_64A1_4B97_BB53_C112896921AB__INCLUDED_)
